VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmConfig 
   Caption         =   "Configure PPT Model"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bCancel 
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   2280
      TabIndex        =   5
      ToolTipText     =   "Click to cancel configuration changes"
      Top             =   2640
      Width           =   1095
   End
   Begin VB.CommandButton bOK 
      Caption         =   "&OK"
      Height          =   495
      Left            =   3480
      TabIndex        =   0
      ToolTipText     =   "Click to accept configuration changes."
      Top             =   2640
      Width           =   1095
   End
   Begin VB.ComboBox cAddress 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   3120
      Style           =   2  'Dropdown List
      TabIndex        =   3
      ToolTipText     =   "Select the address of this unit."
      Top             =   960
      Width           =   1335
   End
   Begin VB.ComboBox cPort 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   3120
      Style           =   2  'Dropdown List
      TabIndex        =   2
      ToolTipText     =   "Select the port that this unit is connected to."
      Top             =   480
      Width           =   1335
   End
   Begin VB.TextBox tName 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   3120
      TabIndex        =   1
      ToolTipText     =   "Enter a name for this unit."
      Top             =   120
      Width           =   1335
   End
   Begin MSFlexGridLib.MSFlexGrid Grid1 
      Height          =   2055
      Left            =   120
      TabIndex        =   4
      ToolTipText     =   "Click to edit setting."
      Top             =   120
      Width           =   2415
      _ExtentX        =   4260
      _ExtentY        =   3625
      _Version        =   393216
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "frmConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit

Private Type CONFIGTYPE
    Name As String
    Port As Integer
    Address As Integer
End Type

Dim Config(65) As CONFIGTYPE

Private Sub UpdateData()
    Dim Cnt As Integer
    Dim Index As Integer
    
    'fill out the grid
    For Cnt = 1 To 64
        
        Index = Cnt * Grid1.Cols
        Grid1.TextArray(Index + 0) = "PPT " + Str(Cnt)
        Grid1.TextArray(Index + 1) = Config(Cnt).Name
        Grid1.TextArray(Index + 2) = fmtPort(Config(Cnt).Port)
        Grid1.TextArray(Index + 3) = fmtAddr(Config(Cnt).Address)
    
    Next Cnt

End Sub


Private Sub bCancel_Click()
    
    'User selected cancel
    Unload Me
    
End Sub


Private Sub bOK_Click()

    'User selected OK, time to commit the changes
    Dim Cnt As Integer
    
    For Cnt = 1 To 64
        
        'Don't allow blank names
        If Len(Config(Cnt).Name) = 0 Then
            Config(Cnt).Name = "PPT" + Str(Cnt) 'default name
        End If
        
        'if either port or address are "(none)" force defaults
        If Config(Cnt).Port = 0 Or Config(Cnt).Address = 0 Then
        
                With PPT(Cnt)
                    .Name = "PPT" + Str(Cnt)
                    .Port = 0
                    .Address = 0
                    .Status = ""
                    .Goal.Value = 0
                    .Goal.Status = ""
                    .Actual.Value = 0
                    .Actual.Status = ""
                    .DownTime.Value = 0
                    .DownTime.Status = ""
                    .Pace.Value = 0
                    .Pace.Status = ""
                    .GScale.Value = 0
                    .GScale.Status = ""
                    .AScale.Value = 0
                    .AScale.Status = ""
                    .DScale.Value = 0
                    .DScale.Status = ""
                    .KHold.Value = 0
                    .KHold.Status = ""
                    .LHold.Value = 0
                    .LHold.Status = ""
                    .KDisable.Value = 0
                    .KDisable.Status = ""
                End With
        
        Else
            
            'update the PPT() structure
            PPT(Cnt).Name = Config(Cnt).Name
            PPT(Cnt).Port = Config(Cnt).Port
            PPT(Cnt).Address = Config(Cnt).Address
        
        End If
        
    Next Cnt
    
    'Now update mass storage with the new values
    Call WriteConfig
    
    'all done, now go away
    Unload Me
    
End Sub


Private Sub cAddress_Click()

    'keep the Config() structrue updated
    Config(Val(cAddress.Tag)).Address = cAddress.ItemData(cAddress.ListIndex)

End Sub


Private Sub cAddress_KeyPress(KeyAscii As Integer)

    'filter keypresses in the Address Combo
    If KeyAscii = Asc(vbCr) Then
        KeyAscii = 0
        cAddress.Visible = False
    End If

End Sub


Private Sub cAddress_LostFocus()

    'Lost Focus, go away
    cAddress.Visible = False
    
    'Update the Grid
    Call UpdateData

End Sub


Private Sub cPort_Click()

    'keep the Config() structrue updated
    Config(Val(cPort.Tag)).Port = cPort.ListIndex
    
End Sub


Private Sub cPort_KeyPress(KeyAscii As Integer)
    
    'filter keypresses in the Port Box
    If KeyAscii = Asc(vbCr) Then
        KeyAscii = 0
        cPort.Visible = False
    End If

End Sub


Private Sub cPort_LostFocus()

    'Lost Focus, go away
    cPort.Visible = False
    
    'Update the Grid
    Call UpdateData

End Sub


Private Sub Form_Load()
    Dim Cnt As Integer
    
    'Restore form to proper position and size
    Me.Left = GetSetting(App.Title, "Settings", "ConfigLeft", 1000)
    Me.Top = GetSetting(App.Title, "Settings", "ConfigTop", 1000)
    Me.width = GetSetting(App.Title, "Settings", "ConfigWidth", 6500)
    Me.height = GetSetting(App.Title, "Settings", "ConfigHeight", 6500)
    
    'Initialize the grid display style
    Grid1.HighLight = flexHighlightNever            'Turn off cell highlighting
    Grid1.ScrollTrack = True                        'Enable ScrollTracking
    Grid1.Cols = 4                                  'Set Table Width
    Grid1.Rows = 65                                 'Set Table Height
    Grid1.ColWidth(1) = (Grid1.ColWidth(1) * 2)     'Make the Column Double Width
    Grid1.ColWidth(2) = (Grid1.ColWidth(2) * 2)     'Make the Column Double Width
    Grid1.ColWidth(3) = (Grid1.ColWidth(3) * 2)     'Make the Column Double Width
    Grid1.FillStyle = flexFillRepeat                'settings apply to table selections
    Grid1.Col = 0: Grid1.Row = 0                    'select top left cell
    Grid1.RowSel = Grid1.Rows - 1                   'select all of the first column
    Grid1.ColSel = Grid1.Cols - 1                   'select the entire table
    Grid1.CellAlignment = flexAlignCenterCenter     'Center Text in the Cell
    Grid1.Col = 0: Grid1.Row = 0                    'select top left cell
    Grid1.ColSel = Grid1.Cols - 1                   'select the top row
    Grid1.CellFontBold = True                       'set text to BOLD
    
    'Set the Grid Column Labels Text
    Grid1.TextArray(0) = "Unit"
    Grid1.TextArray(1) = "PPT Name"
    Grid1.TextArray(2) = "Port"
    Grid1.TextArray(3) = "Address"
    
    'make a local copy of the configuation data
    For Cnt = 1 To 64
        Config(Cnt).Name = PPT(Cnt).Name
        Config(Cnt).Port = PPT(Cnt).Port
        Config(Cnt).Address = PPT(Cnt).Address
    Next Cnt
    
    'hide our edit controls
    tName.Visible = False
    cPort.Visible = False
    cAddress.Visible = False
    
    'Program the Port Selection Combo
    For Cnt = 0 To 16
        cPort.AddItem fmtPort(Cnt)
    Next Cnt
    
    'Program the Address Selection Combo
    cAddress.AddItem fmtAddr(0)
    cAddress.ItemData(cAddress.NewIndex) = 0
    For Cnt = 33 To 126
        cAddress.AddItem fmtAddr(Cnt)
        cAddress.ItemData(cAddress.NewIndex) = Cnt
    Next Cnt
    
    'load up the grid
    Call UpdateData
    
    'start in the upper left
    Grid1.Col = 1
    Grid1.Row = 1
    
End Sub


Private Sub Form_Resize()

    'auto resize the flexgrid to fill the form at run time
    'leave room for the Buttons at the bottom of the form
    Dim Spacing As Integer
    Dim Temp As Integer
    
    'measure the spacing between the buttons
    'set at design time
    Spacing = (bOK.Left - bCancel.Left) - bCancel.width
    
    'move the grid to the upper left corner of the form
    Grid1.Top = 0
    Grid1.Left = 0
    
    'make the grid fill the entire form width
    Grid1.width = frmConfig.ScaleWidth
    
    'make the grid height fill the form but
    'leave room for the buttons, height can NOT be negitive!
    Temp = frmConfig.ScaleHeight - (bOK.height + 2 * Spacing)
    If Temp < 1 Then Temp = 1
    Grid1.height = Temp
    
    'locate the push buttons in the lower right
    bOK.Top = Temp + Spacing
    bOK.Left = frmConfig.ScaleWidth - (bOK.width + Spacing)
    bCancel.Top = Temp + Spacing
    bCancel.Left = bOK.Left - (bCancel.width + Spacing)

End Sub


Private Sub Form_Unload(Cancel As Integer)

    'Save frmConfig position and size
    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "ConfigLeft", Me.Left
        SaveSetting App.Title, "Settings", "ConfigTop", Me.Top
        SaveSetting App.Title, "Settings", "ConfigWidth", Me.width
        SaveSetting App.Title, "Settings", "ConfigHeight", Me.height
    End If

End Sub


Private Sub Grid1_Click()
    
    'edit this cell
    Dim Unit As Integer
        
    'The row cliked on is the Unit
    Unit = Grid1.Row
    
    'The column clicked on is what info
    Select Case Grid1.Col
        Case 1  'Name
            tName.Tag = Unit
            tName.Text = Config(Unit).Name
            tName.SelStart = Len(tName.Text)
            tName.Top = Grid1.CellTop
            tName.Left = Grid1.CellLeft
            tName.width = Grid1.CellWidth
            tName.height = Grid1.CellHeight
            tName.Visible = True
            tName.SetFocus
            
        Case 2  'Port
            cPort.Tag = Unit
            cPort.ListIndex = Config(Unit).Port
            cPort.Top = Grid1.CellTop
            cPort.Left = Grid1.CellLeft
            cPort.width = Grid1.CellWidth
            'cPort.Height = Grid1.CellHeight
            cPort.Visible = True
            cPort.SetFocus
            
        Case 3  'Address
            cAddress.Tag = Unit
            If Config(Unit).Address > 32 And Config(Unit).Address < 127 Then
                cAddress.ListIndex = Config(Unit).Address - 32
            Else
                cAddress.ListIndex = 0
            End If
            cAddress.Top = Grid1.CellTop
            cAddress.Left = Grid1.CellLeft
            cAddress.width = Grid1.CellWidth
            'cAddress.Height = Grid1.CellHeight
            cAddress.Visible = True
            cAddress.SetFocus
            
    End Select

End Sub


Private Sub Grid1_KeyPress(KeyAscii As Integer)

    'filter keypresses in the grid
    If KeyAscii = Asc(vbCr) Then
        KeyAscii = 0
        Call Grid1_Click
    End If

End Sub


Private Sub Grid1_Scroll()

    'if the grid scrolls, kill the edit controls
    'otherwise the grid will scroll under the edit control
    tName.Visible = False
    cPort.Visible = False
    cAddress.Visible = False
    
End Sub


Private Sub tName_Change()
    
    'keep the Config() structrue updated
    Config(Val(tName.Tag)).Name = tName.Text
    
End Sub


Private Sub tName_KeyPress(KeyAscii As Integer)

    'filter keypresses in the tName edit
    If KeyAscii = Asc(vbCr) Then
        KeyAscii = 0
        tName.Visible = False
    End If
    
End Sub


Private Sub tName_LostFocus()

    'Lost Focus, go away
    tName.Visible = False
    
    'Update the Grid
    Call UpdateData
    
End Sub
