VERSION 5.00
Begin VB.Form frmExportSchedule 
   Caption         =   "Automatic Export Schedule"
   ClientHeight    =   9720
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5385
   LinkTopic       =   "Form1"
   ScaleHeight     =   9720
   ScaleWidth      =   5385
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bCancel 
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   3000
      TabIndex        =   2
      ToolTipText     =   "Click to cancel configuration changes"
      Top             =   9120
      Width           =   1095
   End
   Begin VB.CheckBox cbExport 
      Caption         =   "XX:XX AM"
      Height          =   375
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton bOK 
      Caption         =   "&OK"
      Height          =   495
      Left            =   4200
      TabIndex        =   0
      ToolTipText     =   "Click to accept configuration changes."
      Top             =   9120
      Width           =   1095
   End
End
Attribute VB_Name = "frmExportSchedule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit

Private Sub Form_Load()
    Dim x As Integer
    Dim y As Integer
    Dim i As Integer
    Dim pad As Integer
    Dim width As Integer
    Dim height As Integer
    
    'Restore form to proper position
    Me.Left = GetSetting(App.Title, "Settings", "ExportScheduleLeft", 100)
    Me.Top = GetSetting(App.Title, "Settings", "ExportScheduleTop", 100)
    
    'Retrieve padding/spacing from design time
    pad = cbExport(0).Left
    width = cbExport(0).width
    height = cbExport(0).height
    
    'Position the check boxes on the form in a grid like layout
    '24 rows (one per hour of the day), 4 Columns: 00 15 30 45
    For y = 0 To 23
        For x = 0 To 3
        
            'Setup Checkbox Control
            i = y * 4 + x
            If (i <> 0) Then Load cbExport(i)
            cbExport(i).Move pad + width * x, pad + height * y, width, height
            cbExport(i).Caption = MakeExportTime(i)
            cbExport(i).Visible = True
            cbExport(i).Value = AutoExport(i)
        Next x
    Next y
End Sub

Private Sub bOK_Click()

    Dim i As Integer
    
    'Save new Auto Export Schedule
    For i = 0 To NSCHD - 1
        AutoExport(i) = cbExport(i)
    Next i
    
    'Commit change to disk
    Call WriteConfig

    'All Done
    Unload Me
    
End Sub

Private Sub bCancel_Click()
    Dim i As Integer
    
    'User selected cancel
    Unload Me
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    'Save frmExportSchedule position
    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "ExportScheduleLeft", Me.Left
        SaveSetting App.Title, "Settings", "ExportScheduleTop", Me.Top
    End If

End Sub

