VERSION 5.00
Begin VB.Form frmGWriteFlag 
   Caption         =   "frmGWriteFlag"
   ClientHeight    =   1305
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6495
   LinkTopic       =   "Form1"
   ScaleHeight     =   1305
   ScaleWidth      =   6495
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bOption2 
      Caption         =   "Option2"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   4440
      TabIndex        =   3
      Top             =   720
      Width           =   1935
   End
   Begin VB.CommandButton bOption1 
      Caption         =   "Option1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2280
      TabIndex        =   2
      Top             =   720
      Width           =   1935
   End
   Begin VB.CommandButton bCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "Click to cancel the change."
      Top             =   720
      Width           =   1935
   End
   Begin VB.Label lTitle 
      Alignment       =   2  'Center
      Caption         =   "Title"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6135
   End
End
Attribute VB_Name = "frmGWriteFlag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit

Private Sub UpdateDetailData()
    
    'Updates for Change Keyboard Hold Dialog
    If InStr(Me.Tag, "KH") <> 0 Then
        Me.Caption = "Change All Keypad Run/Hold Registers"
        Me.lTitle = Me.Caption
        Me.bOption1.Caption = "Set to Run"
        Me.bOption2.Caption = "Set to Hold"
    End If
    
    'Updates for Change Keyboard Disable Dialog
    If InStr(Me.Tag, "KD") <> 0 Then
        Me.Caption = "Enable / Disable All Keypads"
        Me.lTitle = Me.Caption
        Me.bOption1.Caption = "Set to Enabled"
        Me.bOption2.Caption = "Set to Disabled"
    End If
    
End Sub


Private Sub bCancel_Click()
    
    'User Canceled the update
    'go away
    Unload Me
    
End Sub


Private Sub bOption1_Click()
    Dim Unit As Integer
    
    'User Selected Option1
    'Write RUN to KHold
    If InStr(Me.Tag, "KH") <> 0 Then
        For Unit = 1 To 64
            If PPT(Unit).Port <> 0 Then
                Call PPT(Unit).CmdQueue.Enqueue("WKH0")
            End If
        Next Unit
    End If
    
    'Write Enable to KDisable
    If InStr(Me.Tag, "KD") <> 0 Then
        For Unit = 1 To 64
            If PPT(Unit).Port <> 0 Then
                Call PPT(Unit).CmdQueue.Enqueue("WKD0")
            End If
        Next Unit
    End If
    
    'Go Away
    Unload Me

End Sub

Private Sub bOption2_Click()
    Dim Unit As Integer
    
    'User Selected Option2
    'Write HOLD to KHold
    If InStr(Me.Tag, "KH") <> 0 Then
        For Unit = 1 To 64
            If PPT(Unit).Port <> 0 Then
                Call PPT(Unit).CmdQueue.Enqueue("WKH1")
            End If
        Next Unit
    End If
    
    'Write Disable to KDisable
    If InStr(Me.Tag, "KD") <> 0 Then
        For Unit = 1 To 64
            If PPT(Unit).Port <> 0 Then
                Call PPT(Unit).CmdQueue.Enqueue("WKD1")
            End If
        Next Unit
    End If
    
    'Go Away
    Unload Me

End Sub

Private Sub Form_Activate()
    
    'We were just activated, force an update
    Call UpdateDetailData
    
End Sub

Private Sub Form_Load()

    'Restore form to proper position
    Me.Left = GetSetting(App.Title, "Settings", "GWrite1Left", 1000)
    Me.Top = GetSetting(App.Title, "Settings", "GWrite1Top", 1000)

End Sub

Private Sub Form_Unload(Cancel As Integer)

    'Save form position
    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "GWrite1Left", Me.Left
        SaveSetting App.Title, "Settings", "GWrite1Top", Me.Top
    End If

End Sub
